{-# OPTIONS_HADDOCK show-extensions #-}

-- |
-- Module      :  Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG2
-- Copyright   :  (c) OleksandrZhabenko 2020-2022
-- License     :  MIT
-- Stability   :  Experimental
-- Maintainer  :  olexandr543@yahoo.com
--
-- Generalization and extension of the functionality of the DobutokO.Poetry.Norms
-- and DobutokO.Poetry.Norms.Extended modules
-- from the @dobutokO-poetry@ package. Uses syllables information.
-- Instead of the vector-related, uses just arrays.

module Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG2 (
    -- * Newtype to work with
  CoeffTwo(..)
  , Coeffs2
  , isEmpty
  , isPair
  , fstCF
  , sndCF
  , readCF
  -- * Rhythmicity properties
  -- ** Rhythmicity properties (semi-empirical)
  -- *** General ones
  , rhythmicity0H
  , rhythmicity0FH
  , rhythmicityKH
  , rhythmicityKFH
  -- *** Simple one
  , rhythmicity0
  , rhythmicity0F
  -- *** With weight coefficients
  , rhythmicityK
  , rhythmicityKF
  -- ** Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package (since 0.2.0.0 version)
  -- *** Simple one
  , rhythmicity02
  , rhythmicity02F
  -- *** With weight coefficients
  , rhythmicityK2
  , rhythmicityKF2
  -- ** NEW Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package
  -- *** Simple ones
  , rhythmicity03
  , rhythmicity03F
  , rhythmicity04
  , rhythmicity04F
  -- *** With weight coefficients
  , rhythmicityK3
  , rhythmicityKF3
  , rhythmicityK4
  , rhythmicityKF4
  -- ** General
  , rhythmicityG
  , rhythmicityGH
  , rhythmicity
  , rhythmicityH
  , rhythmicityH'
  -- * Rhythmicity properties extended
  -- ** Rhythmicity properties (semi-empirical)
  -- *** General ones
  , rhythmicity0HTup
  , rhythmicity0FHTup
  , rhythmicityKHTup
  , rhythmicityKFHTup
  -- *** Simple one
  , rhythmicity0Tup
  , rhythmicity0FTup
  -- *** With weight coefficients
  , rhythmicityKTup
  , rhythmicityKFTup
  -- ** Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package (since 0.2.0.0 version)
  -- *** Simple one
  , rhythmicity02Tup
  , rhythmicity02FTup
  -- *** With weight coefficients
  , rhythmicityK2Tup
  , rhythmicityKF2Tup
  -- ** NEW Rhythmicity properties from generated with r-glpk-phonetic-languages-ukrainian-durations package
  -- *** Simple ones
  , rhythmicity03Tup
  , rhythmicity03FTup
  , rhythmicity04Tup
  , rhythmicity04FTup
  -- *** With weight coefficients
  , rhythmicityK3Tup
  , rhythmicityKF3Tup
  , rhythmicityK4Tup
  , rhythmicityKF4Tup
  -- ** General
  , rhythmicityGTup
  , rhythmicityGHTup
  , rhythmicityTup
  , rhythmicityHTup
  , rhythmicityH'Tup
) where

import Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG2Common
import Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG201
import Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG2H
import Phonetic.Languages.Array.Ukrainian.PropertiesSyllablesG2Hprime
